#ifndef _board_h_
#define _board_h_

#include "pkt.h"

#define WALL     '#'
#define PLAIN    '.'
#define WATER    '~'
#define BASE     '@'

typedef struct tile {
  char terrain;
  int  id;
  pkt_list *packages ;
} tile;

typedef struct board {
  int width, height;
  tile **tiles;
} board;

board *get_board(int soc);
struct env;
void display_board(FILE *stream, struct env *e);

#endif
