#ifndef _gui_h_
#define _gui_h_

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <ctype.h>
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
void bzero(void *s, size_t n);
#include <assert.h>

#ifdef GUI
void gui_init(char *server, unsigned short port);
void gui_write(void *txt, int size);
#else
#define gui_init(s, p) do {} while(0)
#define gui_write(t, s) do {} while(0)
#endif

#endif
