

#ifndef IA_H
#define IA_H

#define EMPTY 1
#define PICKING 2
#define SEARCHING 3
#define DELIVERING 4
#define DROPPING 5


#define COEF_FULL_BOUND   1.0

struct env;

int get_prox_base(struct env *e);
void decision(struct env *e);
int move_to_target(struct env *e);
/* int filled_enough(struct env *e); */


#define min(a,b) ((a)<(b)?(a):(b))

#define TARGET_LIMIT_CEILING(a) ( 3 * (a) )
#define BID_IN_CORRIDOR(e) min(3, e->p->money)
#define CRITICAL_BID(e)    min(100, e->p->money)
#define ASSASSIN_BID(e)    min(25, e->p->money)
#define BID_HIT(e)         min(3, e->p->money)
#define BID_DODGE(e)       min(3, e->p->money)

#endif
