#include "main.h"

int strafe_master(env *e)
{
  if(e->state == EMPTY)
    return 0;
  
  /*SAVING MY LIFE*/
  if( (e->b->tiles[e->p->x-1][e->p->y].terrain == WATER ) &&
      (e->b->tiles[e->p->x+1][e->p->y].id != -1) )
    {
      if( (bestmove(e, e->target) == NORTH) &&
	  ISREACHABLE(e, e->p->x, e->p->y+1 ) )
	move(CRITICAL_BID(e), e, NORTH);
      else if(ISREACHABLE(e, e->p->x, e->p->y-1) )
	move(CRITICAL_BID(e), e, SOUTH);
      else
	move(CRITICAL_BID(e), e, EAST);
      e->continue_to_hit = 0;
      return -1;
    }

  if( (e->b->tiles[e->p->x+1][e->p->y].terrain == WATER ) &&
      (e->b->tiles[e->p->x-1][e->p->y].id != -1) )
    {
      if( (bestmove(e, e->target) == SOUTH) &&
	  ISREACHABLE(e, e->p->x, e->p->y-1 ) )
	move(CRITICAL_BID(e), e, SOUTH);
      else if(ISREACHABLE(e, e->p->x, e->p->y+1) )
	move(CRITICAL_BID(e), e, NORTH);
      else
	move(CRITICAL_BID(e), e, WEST);
      e->continue_to_hit = 0;
      return -1;
    }

  if( (e->b->tiles[e->p->x][e->p->y-1].terrain == WATER ) &&
      (e->b->tiles[e->p->x][e->p->y+1].id != -1) )
    {
      if( (bestmove(e, e->target) == WEST) &&
	  ISREACHABLE(e, e->p->x-1, e->p->y ) )
	move(CRITICAL_BID(e), e, WEST);
      else if(ISREACHABLE(e, e->p->x+1, e->p->y) )
	move(CRITICAL_BID(e), e, EAST);
      else
	move(CRITICAL_BID(e), e, NORTH);
      e->continue_to_hit = 0;
      return -1;
    }

  if( (e->b->tiles[e->p->x][e->p->y+1].terrain == WATER ) &&
      (e->b->tiles[e->p->x][e->p->y-1].id != -1) )
    {
      if( (bestmove(e, e->target) == EAST) &&
	  ISREACHABLE(e, e->p->x+1, e->p->y ) )
	move(CRITICAL_BID(e), e, EAST);
      else if(ISREACHABLE(e, e->p->x-1, e->p->y) )
	move(CRITICAL_BID(e), e, WEST);
      else
	move(CRITICAL_BID(e), e, SOUTH);
      e->continue_to_hit = 0;
      return -1;
    }


  /*AVOIDING BEING IN DANGEROUS SITUATION*/
  switch(bestmove(e, e->target))
    {
    case NORTH:
      break;
      if (((e->b->tiles[e->p->x-1][e->p->y+1].terrain == WATER ) 
	   && (e->b->tiles[e->p->x+1][e->p->y+1].id != -1)) 
	  || ((e->b->tiles[e->p->x+1][e->p->y+1].terrain == WATER ) 
	      && (e->b->tiles[e->p->x-1][e->p->y+1].id != -1)))
	{
	  stay(1,e);
	  e->continue_to_hit = 0;
	  return -1;
	}
      
    case SOUTH:
      if (((e->b->tiles[e->p->x-1][e->p->y-1].terrain == WATER ) 
	   && (e->b->tiles[e->p->x+1][e->p->y-1].id != -1)) 
	  || ((e->b->tiles[e->p->x+1][e->p->y-1].terrain == WATER ) 
	      && (e->b->tiles[e->p->x-1][e->p->y-1].id != -1)))
	{
	  stay(1,e);
	  e->continue_to_hit = 0;
	  return -1;
	}
      break;
    case WEST:
      if (((e->b->tiles[e->p->x-1][e->p->y-1].terrain == WATER ) 
	   && (e->b->tiles[e->p->x-1][e->p->y+1].id != -1)) 
	  || ((e->b->tiles[e->p->x-1][e->p->y+1].terrain == WATER ) 
	      && (e->b->tiles[e->p->x-1][e->p->y-1].id != -1)))
	{
	  stay(1,e);	  
	  e->continue_to_hit = 0;
	  return -1;
	}
      break;
    case EAST:
      if (((e->b->tiles[e->p->x+1][e->p->y-1].terrain == WATER ) 
	   && (e->b->tiles[e->p->x+1][e->p->y+1].id != -1)) 
	  || ((e->b->tiles[e->p->x+1][e->p->y+1].terrain == WATER ) 
	      && (e->b->tiles[e->p->x+1][e->p->y-1].id != -1)))
	{
	  stay(1,e);
	  e->continue_to_hit = 0;
	  return -1;
	}
      break;
    }

  /*   CHEEP PUSHING   */
  if ((e->p->x<=1) || (e->p->x>=e->b->width-1) || (e->p->y<=1) || (e->p->y>=e->b->height-1))
    goto next_reflex;
  switch(bestmove(e, e->target))
    {
    case NORTH:
      if ((ISREACHABLE(e,e->p->x,e->p->y+1)) &&
	   (e->b->tiles[e->p->x][e->p->y+2].id != -1))
	{
	  move(-1,e,NORTH);
	  return -1;
	}
      break;
      
      
    case SOUTH:
      if ((ISREACHABLE(e,e->p->x,e->p->y-1)) &&
	   (e->b->tiles[e->p->x][e->p->y-2].id != -1))
	{
	  move(-1,e,SOUTH);
	  return -1;
	}
      break;
    case WEST:
      if ((ISREACHABLE(e,e->p->x-1,e->p->y)) &&
	   (e->b->tiles[e->p->x-2][e->p->y].id != -1))
	{
	  move(-1,e,WEST);
	  return -1;
	}
      break;
    case EAST:
      if ((ISREACHABLE(e,e->p->x+1,e->p->y)) &&
	   (e->b->tiles[e->p->x+1][e->p->y].id != -1))
	{
	  move(-1,e,EAST);
	  return -1;
	}
      break;
    }



  /* KILLING PULSION*/
  if( (e->b->tiles[e->p->x-2][e->p->y].terrain == WATER ) &&
      (e->b->tiles[e->p->x-1][e->p->y].id != -1) &&
      (e->b->tiles[e->p->x-1][e->p->y].terrain != WATER)  &&
      (e->continue_to_hit < 1) )
    {
      e->continue_to_hit++;
      move(ASSASSIN_BID(e), e, WEST);
      return -1;
    }
  if( (e->b->tiles[e->p->x+2][e->p->y].terrain == WATER ) &&
      (e->b->tiles[e->p->x+1][e->p->y].id != -1) &&
      (e->b->tiles[e->p->x+1][e->p->y].terrain != WATER) &&
      (e->continue_to_hit < 1) )
    {
      e->continue_to_hit++;
      move(ASSASSIN_BID(e), e, EAST);
      return -1;
    }
   if( (e->b->tiles[e->p->x][e->p->y-2].terrain == WATER ) &&
       (e->b->tiles[e->p->x][e->p->y-1].id != -1) &&
       (e->b->tiles[e->p->x][e->p->y-1].terrain != WATER) &&
       (e->continue_to_hit < 1) ) 
     {
       e->continue_to_hit++;
       move(ASSASSIN_BID(e), e, SOUTH);
       return -1;
     }
   if( (e->b->tiles[e->p->x][e->p->y+2].terrain == WATER ) &&
       (e->b->tiles[e->p->x][e->p->y+1].id != -1) &&
       (e->b->tiles[e->p->x][e->p->y+1].terrain != WATER) &&
       (e->continue_to_hit < 1) )
     {
       e->continue_to_hit++;
       move(ASSASSIN_BID(e), e, NORTH);
       return -1;
     }
 next_reflex:

   /*PUSHING ADVERSARIES IN CORRIDORS OR DODGING IF POSSIBLE*/
  switch(bestmove(e, e->target))
    {
    case NORTH:
      if( (e->b->tiles[e->p->x][e->p->y+1].id != -1) &&
	  (e->b->tiles[e->p->x][e->p->y+1].terrain != WATER) )
	{
	  if ((e->b->tiles[e->p->x+1][e->p->y].terrain != WATER) &&
	      (e->b->tiles[e->p->x+1][e->p->y].terrain != WALL))
	    {
	      if(e->p->packages.first) {
		if (e->continue_to_hit >= 3)
		  goto stop_hitting;
		move(BID_DODGE(e), e, EAST);
	      } else {
		if (e->continue_to_hit >= 1)
		  goto stop_hitting;
		move(BID_HIT(e), e, NORTH);
	      }

	      return -1;
	    }
	  else
	    if  ((e->b->tiles[e->p->x-1][e->p->y].terrain != WATER) &&
		 (e->b->tiles[e->p->x-1][e->p->y].terrain != WALL))
	      {
		if(e->p->packages.first) {
		  if (e->continue_to_hit >= 3)
		    goto stop_hitting;
		  move(BID_DODGE(e), e, WEST);
		} else {
		  if (e->continue_to_hit >= 1)
		    goto stop_hitting;
		  move(BID_HIT(e), e, NORTH);
		}

		return -1;
	      }	  
	    else
	    {
	      if(e->continue_to_hit >= 3)
		goto stop_hitting;
	      move(BID_IN_CORRIDOR(e), e, NORTH);
	      return -1;
	    }
	}
      break;
    case SOUTH:
      if( (e->b->tiles[e->p->x][e->p->y-1].id != -1) &&
	  (e->b->tiles[e->p->x][e->p->y-1].terrain != WATER) )
	{
	  if ((e->b->tiles[e->p->x+1][e->p->y].terrain != WATER) &&
	      (e->b->tiles[e->p->x+1][e->p->y].terrain != WALL))
	    {
	      if(e->p->packages.first) {
		if (e->continue_to_hit >= 3)
		  goto stop_hitting;
		move(BID_DODGE(e), e, EAST);
	      } else {
		if (e->continue_to_hit >= 1)
		    goto stop_hitting;
		move(BID_HIT(e), e, SOUTH);
	      }

	      return -1;
	    }
	  else if  ((e->b->tiles[e->p->x-1][e->p->y].terrain != WATER) &&
		 (e->b->tiles[e->p->x-1][e->p->y].terrain != WALL))
	      {
		if(e->p->packages.first) {
		  if (e->continue_to_hit >= 3)
		    goto stop_hitting;
		  move(BID_DODGE(e), e, WEST);
		} else {
		  if (e->continue_to_hit >= 1)
		    goto stop_hitting;
		  move(BID_HIT(e), e, SOUTH);
		}

		return -1;
	      }
	  else
	    { 
	      if(e->continue_to_hit >= 3)
		goto stop_hitting;
	      move(BID_IN_CORRIDOR(e), e, SOUTH);
	      return -1;
	    }
	
	}
      break;
    case WEST:
      if( (e->b->tiles[e->p->x-1][e->p->y].id != -1) &&
	  (e->b->tiles[e->p->x-1][e->p->y].terrain != WATER) )
	{
	  if ((e->b->tiles[e->p->x][e->p->y+1].terrain != WATER) &&
	      (e->b->tiles[e->p->x][e->p->y+1].terrain != WALL))
	    {
	      if(e->p->packages.first) {
		if (e->continue_to_hit >= 3)
		  goto stop_hitting;
		move(BID_DODGE(e), e, NORTH);
	      } else {
		if (e->continue_to_hit >= 1)
		  goto stop_hitting;
		move(BID_HIT(e), e, WEST);
	      }

	      return -1;
	    }
	  else
	    if  ((e->b->tiles[e->p->x][e->p->y-1].terrain != WATER) &&
		 (e->b->tiles[e->p->x][e->p->y-1].terrain != WALL))
	      {
		if(e->p->packages.first) {
		  if (e->continue_to_hit >= 3)
		    goto stop_hitting;
		  move(BID_DODGE(e), e, SOUTH);
		} else {
		  if (e->continue_to_hit >= 1)
		    goto stop_hitting;
		  move(BID_HIT(e), e, WEST);
		}

		return -1;
	      }
	    else
	      {
		if(e->continue_to_hit >= 3)
		  goto stop_hitting;
		move(BID_IN_CORRIDOR(e), e, WEST);
		return -1;
	      }
	}
      break;
    case EAST:
      if( (e->b->tiles[e->p->x+1][e->p->y].id != -1) &&
	  (e->b->tiles[e->p->x+1][e->p->y].terrain != WATER) )
	{
	  if ((e->b->tiles[e->p->x][e->p->y+1].terrain != WATER) &&
	      (e->b->tiles[e->p->x][e->p->y+1].terrain != WALL))
	    {
	      if(e->p->packages.first)
		move(BID_DODGE(e), e, NORTH);
	      else
		move(BID_HIT(e), e, EAST);

	      return -1;
	    }
	  else
	    if  ((e->b->tiles[e->p->x][e->p->y-1].terrain != WATER) &&
		 (e->b->tiles[e->p->x][e->p->y-1].terrain != WALL))
	      {
		if(e->p->packages.first) {
		  if (e->continue_to_hit >= 3)
		    goto stop_hitting;
		  move(BID_DODGE(e), e, SOUTH);
		} else { 
		  if (e->continue_to_hit >= 1)
		    goto stop_hitting;
		  move(BID_HIT(e), e, EAST);
		}

		return -1;
	      }
	    else
	      {
		if(e->continue_to_hit >= 3)
		  goto stop_hitting;
		move(BID_IN_CORRIDOR(e), e, EAST);
		return -1;
	      }
	}
      break;
    }
  return 0;
stop_hitting:
  e->continue_to_hit = 0;
  return 0;
}
