#ifndef _base_h_
#define _base_h_

#include "pkt.h"

typedef struct base {
  int x;
  int y;
  pkt_list *packages;
  unsigned int limit;
  struct base *next;
}base;

typedef struct bases {
  int nb_bases;
  base *first;
  base *last;
}bases;

struct env;
struct bases *init_bases(struct env *e);
void lookup_all_bases(struct env *e);
struct base *add_base(bases *bs,int x,int y);
void print_bases(struct env *e);
void remove_base(bases *bs,int x,int y);
base *find_base(bases *bs,int x,int y);
void base_update_limit(base *b);
unsigned int allbases_limit(bases *bs);

#endif
