#include "main.h"

void init_topo_layer(env *e)
{
  int x,y;
  int sum;
  e->topo_layer=(int **)calloc(e->b->width,sizeof(int *));
  for(x=0;x<e->b->width;x++)
    e->topo_layer[x]=(int *)calloc(e->b->height,sizeof(int));

  for (x=1;x<e->b->width-1;x++)
    for(y=1;y<e->b->height-1;y++)
      {
	if (ISPLAIN(e,x,y))
	  {
	    if((ISWATER(e,x+1,y) || ISWATER(e,x-1,y) 
		|| ISWATER(e,x,y+1) || ISWATER(e,x,y-1)) &&
	       !( ISWATER(e, x+1, y) && ISWATER(e, x-1, y) && !ISWATER(e, x, y+1) && !ISWATER(e, x, y-1) ) &&
	       !( ISWATER(e, x, y+1) && ISWATER(e, x, y-1) && !ISWATER(e, x+1, y) && !ISWATER(e, x-1, y) ) )
	      e->topo_layer[x][y]=2;
	  } 
      }
  for (x=1;x<e->b->width-1;x++)
    for(y=1;y<e->b->height-1;y++)
      {
	sum=0;
	if (ISPLAIN(e,x,y) && (e->topo_layer[x][y]==0))
	  {
	    if (ISWATERNEIGHB(e,x+1,y))
	      sum++;
	    if (ISWATERNEIGHB(e,x-1,y))
	      sum++;
	    if (ISWATERNEIGHB(e,x,y+1))
	      sum++;
	    if (ISWATERNEIGHB(e,x,y-1))
	      sum++;
	    if (sum>=2)
	      e->topo_layer[x][y]=1;
	  } 
      }
  for (x=1;x<e->b->width-1;x++)
    for(y=1;y<e->b->height-1;y++)
      if (e->topo_layer[x][y]==1)
	e->topo_layer[x][y]=2;
}
