#ifndef _main_h_
#define _main_h_

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <ctype.h>
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
void bzero(void *s, size_t n);
#include <assert.h>


#define BINPACK_RADIUS(e)  (e->b->width / 5)
#define TARGET_X 11
#define TARGET_Y 11
#define MAX_MEMORY_SPACE_FOR_BEDFORD_TABLES_IN_BYTES (40 * 1024 * 1024)

#define ISREACHABLE(e,x,y) \
(((e)->b->tiles[(x)][(y)].terrain==PLAIN) ||\
 ((e)->b->tiles[(x)][(y)].terrain==BASE))

#define ISPLAIN(e,x,y) ((e)->b->tiles[(x)][(y)].terrain==PLAIN)

#define ISWATER(e,x,y) ((e)->b->tiles[(x)][(y)].terrain==WATER)

#define ISWATERNEIGHB(e,x,y) (e->topo_layer[x][y]==2)

#include "pkt.h"
#include "player.h"
#include "board.h"
#include "base.h"
#include "layer.h"
#include "env.h"
#include "net.h"
#include "bedford.h"
#include "reflex.h"
#include "ia.h"
#include "gui.h"

#endif
