#ifndef _player_h_
#define _player_h_

#define EMPTY_PLACE(e)  ((e)->p->available->first==NULL)
#define EMPTY_BAG(e)    ((e)->p->packages.first==NULL)



typedef struct player {
  int x;
  int y;
  unsigned int capacity;
  int money;
  int id;
  char dead;
  pkt_list *available;
  pkt_list packages;
  struct player *next;
}player; 

typedef struct player_list {
  player *first;
  player *last;
}player_list;

#include "env.h"

player *get_good_player(int soc);
void display_player(FILE *stream, player *p);
void player_add_adv(env *e, player *p);
player *player_get_or_create_by_id(int id, env *e);
void player_update_packages_position(player *p);

#endif
